﻿using System;
using System.Linq;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Profiles.Quest.Order;
using Styx.Plugins;

namespace AnniversaryBuff
{
    public class AnniversaryBuffPlugin : HBPlugin
    {
        public override string Name => "Anniversary Buff Plugin";
        public override string Author => "Studio60";
        public override Version Version => new Version(1, 2, 0);

        private readonly ProfileHelperFunctionsBase _profileHelper = new ProfileHelperFunctionsBase();
        private DateTime _throttle = DateTime.MinValue;
        private Random _rnd = new Random();

        public override void OnEnable()
        {
            Logging.Write("[Studio60] Anniversary Buff Plugin by Studio60 is now enabled.");
        }

        public override void OnDisable()
        {
            Logging.Write("[Studio60] Anniversary Buff Plugin by Studio60 is now disabled.");
        }

        public override void Pulse()
        {
            if (_throttle > DateTime.Now)
                return;

            if (!StyxWoW.Me.IsAlive || !StyxWoW.IsInWorld || StyxWoW.Me.Combat || StyxWoW.Me.Mounted || StyxWoW.Me.IsFlying || StyxWoW.Me.InVehicle)
            {
                SetThrottle();
                return;
            }

            if (StyxWoW.Me.HasAura(219159))
            {
                SetThrottle();
                return;
            }

            if (!_profileHelper.HasItem(139285))
            {
                SetThrottle();
                return;
            }

            var item = StyxWoW.Me.BagItems.FirstOrDefault(i => i.Entry == 139285);

            if (SpellManager.GlobalCooldown || item == null || item.CooldownTimeLeft > TimeSpan.Zero)
            {
                SetThrottle();
                return;
            }

            item.Use();
            SetThrottle();
            Logging.Write("[Studio60] Anniversary Buff activated");
        }

        private void SetThrottle()
        {
            _throttle = DateTime.Now.AddMilliseconds(_rnd.Next(5000, 10000));
        }
    }
}